SystemOrganization addCategory: #'XPForums-Networking-Core'!
SystemOrganization addCategory: #'XPForums-Networking-Server'!

Object subclass: #XpfEntity
	instanceVariableNames: 'type data'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPForums-Networking-Core'!

!XpfEntity methodsFor: 'accessing' stamp: 'SR 9/8/2009 11:46'!
data

	^ data! !

!XpfEntity methodsFor: 'accessing' stamp: 'SR 9/8/2009 11:46'!
data: anObject

	data := anObject! !

!XpfEntity methodsFor: 'initialization' stamp: 'SR 9/8/2009 11:46'!
initialize

	^ super initialize! !

!XpfEntity methodsFor: 'accessing' stamp: 'SR 9/8/2009 11:43'!
type

	^ type! !

!XpfEntity methodsFor: 'accessing' stamp: 'SR 9/8/2009 11:43'!
type: anObject

	type := anObject! !

Object subclass: #XpfTcpTextServer
	instanceVariableNames: 'port listenSocket clientWorkerList listenProcess'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPForums-Networking-Server'!

XpfTcpTextServer subclass: #XpfTcpEchoServer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPForums-Networking-Server'!

!XpfTcpEchoServer methodsFor: 'as yet unclassified' stamp: 'SR 9/8/2009 12:18'!
processLine: aString

	Transcript show: aString; cr.
	^ aString! !

!XpfTcpTextServer methodsFor: 'accessing' stamp: 'SR 9/8/2009 12:03'!
clientWorkerList

	^ clientWorkerList! !

!XpfTcpTextServer methodsFor: 'accessing' stamp: 'SR 9/8/2009 12:03'!
clientWorkerList: anObject

	clientWorkerList := anObject! !

!XpfTcpTextServer methodsFor: 'as yet unclassified' stamp: 'SR 9/8/2009 12:03'!
initialize

	super initialize.
	Socket initializeNetwork.
	
	self
		port: 54320;
		clientWorkerList: OrderedCollection new.! !

!XpfTcpTextServer methodsFor: 'accessing' stamp: 'SR 9/8/2009 12:16'!
listenProcess

	^ listenProcess! !

!XpfTcpTextServer methodsFor: 'accessing' stamp: 'SR 9/8/2009 12:16'!
listenProcess: anObject

	listenProcess := anObject! !

!XpfTcpTextServer methodsFor: 'accessing' stamp: 'SR 9/8/2009 11:55'!
port

	^ port! !

!XpfTcpTextServer methodsFor: 'accessing' stamp: 'SR 9/8/2009 11:55'!
port: anObject

	port := anObject! !

!XpfTcpTextServer methodsFor: 'as yet unclassified' stamp: 'SR 9/8/2009 11:53'!
processLine: aString

	self subclassResponsibility.! !

!XpfTcpTextServer methodsFor: 'as yet unclassified' stamp: 'SR 9/8/2009 12:25'!
processSocket: aSocket
 	
	^ [
		| stream |      
		stream := SocketStream on: aSocket.
     	[
	    		aSocket notNil and: [stream isConnected]] whileTrue: [|data response|
	      		data := stream upToAll: String crlf.
				data = '.'
					ifTrue: [aSocket closeAndDestroy. response := nil]
					ifFalse: [response := self processLine: data].
				response isNil ifFalse: [
           			stream
             				nextPutAll: response;
             				crlf;
             				flush
				].
       	].
       	aSocket ifNotNil: [aSocket closeAndDestroy].
	] fork.! !

!XpfTcpTextServer methodsFor: 'as yet unclassified' stamp: 'SR 9/8/2009 12:15'!
running

	^ self listenProcess isNil not! !

!XpfTcpTextServer methodsFor: 'as yet unclassified' stamp: 'SR 9/8/2009 12:17'!
startServer

	| |
	self running ifTrue: [^ self].
	
	listenSocket := Socket newTCP.
	listenSocket listenOn: (self port) backlogSize: 4.
   	self listenProcess: (
		[
			[true] whileTrue: [ | socket |
				socket := listenSocket waitForAcceptFor: 60.
				self clientWorkerList add: (self processSocket: socket).
		
			]
		] fork).! !

!XpfTcpTextServer methodsFor: 'as yet unclassified' stamp: 'SR 9/8/2009 12:17'!
stopServer

	self running ifFalse: [^ self].
	
	self listenProcess terminate.
	listenSocket closeAndDestroy.
	
	self clientWorkerList do: [:element |
		element isTerminated ifFalse: [element terminate]].! !

Object subclass: #XpfType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPForums-Networking-Core'!
